/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessageCard type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageCard{}

// MessageCard struct for MessageCard
type MessageCard struct {
	Text string `json:"text"`
	Buttons []MessageButton `json:"buttons"`
}

// NewMessageCard instantiates a new MessageCard object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageCard(text string, buttons []MessageButton) *MessageCard {
	this := MessageCard{}
	this.Text = text
	this.Buttons = buttons
	return &this
}

// NewMessageCardWithDefaults instantiates a new MessageCard object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageCardWithDefaults() *MessageCard {
	this := MessageCard{}
	return &this
}

// GetText returns the Text field value
func (o *MessageCard) GetText() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Text
}

// GetTextOk returns a tuple with the Text field value
// and a boolean to check if the value has been set.
func (o *MessageCard) GetTextOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Text, true
}

// SetText sets field value
func (o *MessageCard) SetText(v string) {
	o.Text = v
}

// GetButtons returns the Buttons field value
func (o *MessageCard) GetButtons() []MessageButton {
	if o == nil {
		var ret []MessageButton
		return ret
	}

	return o.Buttons
}

// GetButtonsOk returns a tuple with the Buttons field value
// and a boolean to check if the value has been set.
func (o *MessageCard) GetButtonsOk() ([]MessageButton, bool) {
	if o == nil {
		return nil, false
	}
	return o.Buttons, true
}

// SetButtons sets field value
func (o *MessageCard) SetButtons(v []MessageButton) {
	o.Buttons = v
}

func (o MessageCard) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageCard) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["text"] = o.Text
	toSerialize["buttons"] = o.Buttons
	return toSerialize, nil
}

type NullableMessageCard struct {
	value *MessageCard
	isSet bool
}

func (v NullableMessageCard) Get() *MessageCard {
	return v.value
}

func (v *NullableMessageCard) Set(val *MessageCard) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageCard) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageCard) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageCard(val *MessageCard) *NullableMessageCard {
	return &NullableMessageCard{value: val, isSet: true}
}

func (v NullableMessageCard) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageCard) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


